*******************************************************************************;
* vO: P01-03-02.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: R߁@Q̕ϒl̔r                                  *;
* gpړI: Kruskal-Wallis̏ʌ                                          *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: Kruskal-Wallis̏ʌ';
footnote 'Program: P01-03-02.SAS';

* ----- Tvf[^쐬;
data DT202;
  input DRUG $ @@;
  drop I;
  do I=1 to 10;
    input VAL @@;
    output;
  end;
  cards;
A 144 148 147 138 137 140 141 138 146 145
B 148 142 137 132 141 134 147 142 136 141
C 142 138 141 140 132 131 143 132 128 135
D 144 128 116 125 136 129 131 128 111 114
;
run ;

proc print data=DT202;
run;

* ----- freqvVWɂKruskal-Wallis̏ʌ;
proc freq data=DT202;
  tables DRUG*VAL/noprint cmh2 scores=rank;
  output out=OUT cmh2;
run;
proc print data=OUT;
run;

* ----- NPAR1WAYvVWɂKruskal-Wallis̏ʌ;
proc npar1way data=DT202 wilcoxon noprint;
  class DRUG;
  var VAL;
  output out=OUT;
run;

proc print data=OUT;
run;

