*******************************************************************************;
* vO: P01-09-06.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: X߁@ԉ                                        *;
* gpړI: ֐̈قȂw܂ރf[^𐶑ԉ͂(wʐԉ)*;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;
           
* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title f=mincho 'Title: Kaplan-Meier@ɂ鐶̐';
footnote 'P01-09-06.SAS';
           
* ----- Tvf[^쐬;
data KM ;
  call streaminit(4649);
  do N=1 to 150 ;
     CPAT=RAND('UNIFORM') ;
    if CPAT=<0.55 then do TRT=0 ; STAGE=1 ; TIME=RAND('WEIBULL',1.3,7/(log(2)**1.3)); end ;
    if CPAT >0.55 then do TRT=0 ; STAGE=2 ; TIME=RAND('WEIBULL',0.4,3/(log(2)**0.4)); end ;
    RCEN=RAND('UNIFORM') ;
    if RCEN<0.05 then CENSOR=0 ; else CENSOR=1 ;
    if TIME>30 then do ; TIME=30 ; CENSOR=0 ; end ;
    output ;
  end ;
  do N=1 to 150 ;
    TPAT=RAND('UNIFORM') ;
    if TPAT=<0.5  then do TRT=1 ; STAGE=1 ; TIME=RAND('WEIBULL',1.3,9.5/(log(2)**1.3)); end ;
    if TPAT >0.5  then do TRT=1 ; STAGE=2 ; TIME=RAND('WEIBULL',0.45,5.5/(log(2)**0.45)); end ;
    RCEN=RAND('UNIFORM') ;
    if RCEN<0.05 then CENSOR=0 ; else CENSOR=1 ;
    if TIME>30 then do ; TIME=30 ; CENSOR=0 ; end ;
    output ;
  end ;
run;

proc sort data=KM;
  by  trt STAGE ;
run;


* ----- dΐvbg̕\igplotvVWgpj;
proc lifetest data=KM outs = OUTSR plots=(s,lls) noprint;
  time TIME*CENSOR(0);
  strata STAGE / group=TRT ;
run;
data OUTLL ;
  set OUTSR ;
  attrib LLSURVIVAL length=8 ;
  attrib LLTIME     length=8 ;
  LLSURVIVAL= log(log(SURVIVAL)*-1);
  LLTIME    = log(TIME) ;
run ;
title "Stage=12̐֐iΐϊj" ;
proc gplot data=OUTLL ;
  axis1 label=(font=kanji  h=1.5 'Ԃ̑ΐϊ');
  axis2 label=(font=kanji  h=1.5 angle=-90 rotate=90 'KMʂ̓dΐϊ');
  symbol1 interpol=join line=1 value=none color=black width=1 ;
  symbol2 interpol=join line=3 value=none color=black width=1 ;
  plot LLSURVIVAL*LLTIME=STAGE /haxis=axis1 vaxis=axis2;
run ;
quit;


* ----- LIFETESTvVWɂwʐԉ;
ods output HOMTESTS = OUT ;
proc lifetest data=KM plots=(s);
  time TIME*CENSOR(0);
  strata STAGE / group=TRT ;
run;
quit;

proc print data=OUT;
run;

* -----wʈqƎÌʂƂ̌ݍp̌;
proc phreg data=KM ;
  class TRT STAGE /ref=first param=ref;
  model TIME*CENSOR(0)=TRT TRT*STAGE / rl  type3(score) ;
  strata STAGE ;
run ;
quit;

