*******************************************************************************;
* vO: P01-01-02.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: P߁@f[^̗v                                        *;
* gpړI: Hodges-Lehmann                                                *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;
* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: Hodges-Lehmann';
footnote 'Program: P01-01-02.SAS';


* ----- f[^쐬;
data REACT;
  input STIM TIME @@;
  datalines;
1 1.94   1 1.94   1 2.92   1 2.92   1 2.92   1 2.92   1 3.27
1 3.27   1 3.27   1 3.27   1 3.70   1 3.70   1 3.74
2 3.27   2 3.27   2 3.27   2 3.70   2 3.70   2 3.74
;
run;
proc print data=REACT;run;
proc npar1way hl (refclass =1) alpha=.05 data=REACT;
  class STIM;
  var TIME;
  exact hl;
  ods select WilcoxonScores HodgesLehmann;
run;

/*npar1waygpHodges-LehmannʂZo*/
/*f[^H*/
data REACT1;
  set REACT;
  where STIM=1;
  i=_n_;
  rename TIME=X;
run;
data REACT2;
  set REACT;
  where STIM=2;
  j=_n_;
  rename  STIM= STIM2 ;
  rename TIME=Y ;
run;
/*ς\*/
proc sql noprint;
  create table DIFF as 
    select * from REACT1,REACT2;
quit;
data DIFF;
  set DIFF;
  DIFF=Y-X;
run;
proc univariate data=DIFF normal;
  var DIFF;
  output out=MEDIAN median=MEDIAN;
run;
