*******************************************************************************;
* vO: P01-04-04.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: S߁@ւƉA                                          *;
* gpړI: `ŏQ@̂Ă͂߂                              *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: `ŏ2@̂Ă͂߂';
footnote 'Program: P01-04-04.SAS';

* ----- Tvf[^쐬;
data WK1;
  input T C1 @@;
  cards;
 0.0 0.180  2.5 0.109  5.0 0.091 10.0 0.082
15.0 0.073 20.0 0.064 30.0 0.051 40.0 0.045
;
run;

proc nlin data=WK1 method=gauss;
  parms    A=0.1
           ALPHA=0.02
           B=0.08
           BETA=0.69;
  bounds   A>0,ALPHA>0,B>0,BETA>0;
  model    C1=A*exp(-ALPHA*T)+B*exp(-BETA*T);
           der.A=exp(-ALPHA*T);
           der.ALPHA=-A*T*exp(-ALPHA*T);
           der.B=exp(-BETA*T);
           der.BETA=-B*T*exp(-BETA*T);
run; 
