*******************************************************************************;
* vO: P01-07-05.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: V߁@dr                                            *;
* gpړI: Steel-Dwasš(mpgbNłTukey̑dr)          *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: Steel-Dwasš(mpgbNłTukey̑dr)';
footnote 'Program: P01-07-05.SAS';

* ----- Tvf[^쐬;
data DAT1;
  keep GROUP ATAI;
  do GROUP=1 to 3;
    do ATAI=1 to 6;
      input FREQ @@;
      do LOOP=1 to FREQ;
        output;
      end;
    end;
  end;
  cards;
5  6 21 16 23  6
7  4 33 21 10  1
3  6 37  9 15  1
;
run ;

proc print data=DAT1;
run;

* ----- }Nϐ`;
%let NG=3; * Q̑;

* ----- Steel-Dwasš;

Data TEMP1; set DAT1;
  do GUN1=1 to &NG;
    do GUN2=GUN1+1 to &NG;
      if GROUP = GUN1 then output;
      if GROUP = GUN2 then output;
    end;
  end;
run;

proc sort data=TEMP1;
  by GUN1 GUN2;
run;

proc npar1way wilcoxon data=TEMP1 noprint;
  class GROUP;
  var ATAI;
  by GUN1 GUN2;
  output out=TEMP2;
run;

data TEMP3;set TEMP2;
  Z=sqrt(_KW_);
  P=1-probmc('range',abs(Z*sqrt(2)),.,.,&NG);
run;

proc print data=TEMP3;
  var GUN1 GUN2 Z P;
run;
