*******************************************************************************;
* vO: P01-09-02.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: X߁@ԉ                                        *;
* gpړI: ONAʉECRN\                          *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: ONAʉECRN\';
footnote 'Program: P01-09-02.SAS';

* ----- tH[}bg쐬;
proc format;
  value TRTF    0='CONTROL ' 
                1='NEW-DRUG ';
  value CENSORF 0='CENSORED' 
                1='EVENT';
run;

* ----- Tvf[^쐬;

data KM;
  do TRT=0,1;
    do i=1 to 16;
      input TIME CENSOR @@;output;
  end;end;
  format TRT TRTF. CENSOR CENSORF.;
  keep TRT TIME CENSOR;
cards;
 4 1  5 1  7 1  7 1 12 1 14 0 17 1 20 1
22 1 31 1 34 0 34 1 43 1 45 0 50 1 52 1
 9 1 12 1 14 0 20 1 20 1 25 1 26 1 31 0
34 0 41 1 45 0 48 1 55 1 60 1 62 0 77 0
;
run;

proc print data=KM;
run;

* ----- LIFETESTvVWɂ郍ONAʉECRN\;
proc lifetest data=KM notable;
  time TIME*CENSOR(0);
  strata TRT;
run;
