*******************************************************************************;
* vO: P02-02-02.SAS                                                 *;
* eLXg̏: Q́@SAS/RpX̗ᐔ݌v                     *;
* eLXg̐: Q߁@QQ̔r                                      *;
* gpړI: vʒl̔򐫎̗ᐔ߂                                  *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: vʒl̔򐫎̗ᐔ߂';
footnote 'Program: P02-02-02.SAS';

*--- vʒl̔򐫎̗ᐔ݌v ---*;
/*-----p[^w---------------------------------------------------------*/
/*   MU_A  : 팱A̕ϒl                                                  */
/*   MU_B  : ΏƖB̕ϒl                                                  */
/*   SD    : 2Q̋ʂ̕W΍                                              */
/*   DELTA : E                                                         */
/*   ALPHA : БLӐ(P̉ߌ)                                       */
/*   BETA  : 2̉ߌ                                                      */
/*----------------------------------------------------------------------------*/
%macro NI(MU_A, MU_B, SD, DELTA, ALPHA, BETA);
  data WORK1;
    MU_A=&MU_A;
    MU_B=&MU_B;
    SD=&SD;
    ALPHA=&ALPHA;
    BETA=&BETA;
    DELTA=&DELTA;
    ZALPHA=probit(1-ALPHA);
    ZBETA=probit(1-BETA);
    N=2*(((ZALPHA+ZBETA)/((MU_A-MU_B+DELTA)/SD))**2);
  run;

  proc print data=WORK1;
    var MU_A MU_B SD ALPHA BETA DELTA ZALPHA ZBETA N;
  run;
%mend;

%NI(50, 50, 20, 10, 0.025, 0.20); 

*--- POWERvVWpꍇ ---*;
proc power;
  twosamplemeans test = diff
  sides          = 1
  groupmeans     = 50 | 50
  nulldiff       = 10
  stddev         = 20
  alpha          = 0.025
  power          = 0.80
  groupweights   = (1 1)
  ntotal         = .;
run;
