*******************************************************************************;
* vO: P02-03-02.SAS                                                 *;
* eLXg̏: Q́@SAS/RpX̗ᐔ݌v                     *;
* eLXg̐: R߁@pʔ                                        *;
* gpړI: Qlf[^i䗦j̗pʔ̗ᐔ߂                    *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: vl̗pʔ̗ᐔ߂';
footnote 'Program: P02-03-02.SAS';

*--- vl̗pʔ̗ᐔ݌v(Cochran-Armitage) ---*;
/*-----p[^w---------------------------------------------------------*/
/*  ALPHA  : БLӐ(P̉ߌ)                                       */
/*  BETA   : 2̉ߌ                                                      */
/*  VALUES : eQ̗LiBlank؂ŗ񋓁j                                */
/*  K      : Q̐                                                           */
/*  VALUESɒpʁi邢͍pʁj珇ɑzLBlank؂         */
/*  ׂ邱ƂɂAQ̐Ɋ֌WȂKvȗᐔ߂邱ƂłB        */
/*----------------------------------------------------------------------------*/
%macro CA(ALPHA, BETA, VALUES, K);
  data CA;
    retain SUM CCPQ CP 0;
  * ----- p[^w;
    ALPHA=&ALPHA;
    BETA=&BETA;
    K=&K;
  * ----- vZ;
    ZALPHA=probit(1-ALPHA);
    ZBETA=probit(1-BETA);
  * ----- ᐔvZ;
    %do I=1 %to &k;
      %let P&I= %scan(&VALUES, &I, ' ');
      G&I=&&P&I;
      SUM=SUM+(&&P&I);
      CCPQ=CCPQ+((&I-1)-(K-1)/2)*((&I-1)-(K-1)/2)*(&&P&I)*(1-&&P&I);
      CP=CP+((&I-1)-(K-1)/2)*(&&P&I);
    %end;
    P=sum/K;
    Q=1-P;
    N0=(((ZALPHA*sqrt((K*(K**2-1)*P*Q)/12)+ZBETA*sqrt(CCPQ)))/CP)**2;
    N=(N0/4)*((1+sqrt(1+2/(N0*CP)))**2);
  run;

  proc print;
  run;
%mend ca;

%ca(0.025,0.2,'0.4 0.6 0.8',3);

*--- POWERvVWpꍇ ---*;
proc power;
  onewayanova
  groupmeans     = 0.4 | 0.6 | 0.8
  sides          = 1
  stddev         = 0.4889
  alpha          = 0.025
  npergroup      = .
  power          = 0.80
  contrast       = (-1 0 1);
run;
